#
#            RiSearch
#
# web search engine, version 1.0.01
# (c) Sergej Tarasov, 2000-2004
#
# Homepage: http://risearch.org/
# email: risearch@risearch.org

package lib::admin_lib;
use lib::common_lib;
use lib::spider_lib;
use lib::index_lib;
use strict;
use riconfig;
use vars qw(@ISA @EXPORT);
no warnings;


use Exporter;
@ISA = ('Exporter');
@EXPORT = qw(
             &read_template &print_template
             &change_password
             &config_show &config_update &reindex
             
             %param
             );

use vars  qw(
             %param
             );


%param = ();

#=====================================================================
#
#    Function: reindex
#    Last modified: 28.08.2003 14:36
#
#=====================================================================

sub reindex {

    if ($param{'type'} eq "L") {
         open(PROC, "perl index.pl -passw=$param{'pass'} |") or print "Can't run program: $!\n";
         while(<PROC>) {
             print $_;
         }
         close(PROC);
    } else {
         open(PROC, "perl spider.pl -passw=$param{'pass'} |") or print "Can't run program: $!\n";
         while(<PROC>) {
             print $_;
         }
         close(PROC);
    }

}
#=====================================================================
#
#    Function: change_password
#    Last modified: 28.08.2003 14:36
#
#=====================================================================

sub change_password {

    if ($param{'pass1'} ne $param{'pass2'}) {
        print "Retype new passwords\n";
    } else {
        if (-e "0_passwd") {
            open IN, "0_passwd" or print "Can't open password file - $!\n";
            my $old_passwd = <IN>;
            close(IN);
            if (crypt($param{'pass3'}, $old_passwd) eq $old_passwd) {
                my $cr_pass = crypt($param{'pass1'}, join '', ('.', '/', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64]);
                open OUT, ">0_passwd" or print "Can't open password file - $!\n";
                print OUT $cr_pass;
                close(OUT);
                print "Password is changed\n";
            } else {
                print "Type correct old password\n";
            }
        } else {
            my $cr_pass = crypt($param{'pass1'}, join '', ('.', '/', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64]);
            open OUT, ">0_passwd" or print "Can't open password file - $!\n";
            print OUT $cr_pass;
            close(OUT);
            print "Password is changed\n";
        }
    }
    
}
#=====================================================================
#
#    Function: config_show
#    Last modified: 04.10.2003 10:24
#
#=====================================================================

sub config_show {

my %templates = read_template($cfg{config_template});

print print_template($templates{"header"},%cfg);

$cfg{rules} =~ s|(\x0D?\x0A)+|\x0A|sg;

print print_template($templates{"config"},%cfg);

print print_template($templates{"footer"},%cfg);

    
}
#=====================================================================
#
#    Function: config_update
#    Last modified: 29.09.2003 18:27
#
#=====================================================================

sub config_update {
    
    
    my $orig_conf = "";
    my $new_conf  = "";
    open CONF, "riconfig.pm" or my_die("Died: can't open riconfig.pm: $!",__LINE__,__FILE__);
    my $old_size = (stat(CONF))[7];
    read(CONF, $orig_conf, $old_size);
    $new_conf = $orig_conf;
    
    while ( my ($k,$v) = each %param) {
        $new_conf =~ s|^(\s*)($k)(\s*=>\s*["']?)(.*?)(['"]?,\s)|$1$k$3$v$5|m;
    }
    
    my $k = 'rules';
    my $v = $param{rules};
    $v =~ s|(\x0D?\x0A)+|\x0A|sg;

    $new_conf =~ s|(\x0A\s*)($k)(\s*=>\s*q\(\s*)(.*?)\s*(\),\s)|$1$k$3$v\x0A$5|s;
    
    open CONF, ">riconfig.pm" or my_die("Died: can't open riconfig.pm: $!",__LINE__,__FILE__);
    print CONF $new_conf;
    close(CONF);
    
    %cfg = (%cfg, %param);
    

    config_show();
    
}
#===================================================================



1;